#DELMACHE Benjamin / TANGENT'DELTA / CREATION : 05/05/2014 / MODIF : 25/06/14

def dyna_visco_modes(self,TYPE_CALCUL,MATER_ELAS_FO,FREQ,LIST_FREQ,EPSILON,TYPE_MODE,NP,RPROJ,__asseKg,trKg,__listKv,e0,eta0,ltrv,__asseMg,fmax,__asseKgr,list_FREQ,**args):

                   
    from Accas import _F
    from Utilitai.Utmess     import UTMESS
    from math import exp
    import aster
    import numpy as NP

    COMB_MATR_ASSE  =self.get_cmd('COMB_MATR_ASSE')
    MODE_ITER_SIMULT = self.get_cmd('MODE_ITER_SIMULT')
    CREA_CHAMP = self.get_cmd('CREA_CHAMP')
    CREA_RESU = self.get_cmd('CREA_RESU')
    DEFI_BASE_MODALE = self.get_cmd('DEFI_BASE_MODALE')
    DETRUIRE = self.get_cmd('DETRUIRE')
    EXTR_MODE = self.get_cmd('EXTR_MODE')
    CREA_TABLE = self.get_cmd('CREA_TABLE')
    
    i=0  
    nmode=5
    amor_mod=[]
    freqp=[]


    # Recuperation des donnes des mots clefs lors du calcul des modes
    if args.has_key('AMOR'):        
      AMOR      = args['AMOR']
      self.DeclareOut('amor',AMOR)

    if TYPE_CALCUL=='MODE':
      self.DeclareOut('modes',self.sd)




# CALCUL DES MODES REELS DEPENDANT DE LA FREQUENCE

    freq1=list_FREQ[0]
    dfreq=freq1
    j=0


    if TYPE_MODE=='BETA':

        while abs(dfreq)>=EPSILON*freq1:

          if i>10:
            nmode=nmode+5
            i=0

          __asseKw=__asseKg
          ny=0
          betab=NP.real(trKg)
          betah=NP.imag(trKg)

          for y in MATER_ELAS_FO:
              e=y['E'](freq1)
              eta=y['AMOR_HYST'](freq1)

              __asseKw=COMB_MATR_ASSE(COMB_C=(_F(MATR_ASSE=__asseKw,
                                                COEF_R=1.),
                                             _F(MATR_ASSE=__listKv[ny],
                                                COEF_C=('RI',e/e0[ny]-1,eta*e/e0[ny]-eta0[ny],),),),)

              betab=betab+(e/e0[ny]-1)*ltrv[ny]
              betah=betah+(eta*e/e0[ny]-eta0[ny])*ltrv[ny]
              ny=ny+1

          __asseKw=COMB_MATR_ASSE(COMB_R=(_F(MATR_ASSE=__asseKw,
                                            PARTIE='REEL',
                                            COEF_R=1.),
                                         _F(MATR_ASSE=__asseKw,
                                            PARTIE='IMAG',
                                            COEF_R=betah/betab,),),)



            
          __modreel=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                    MATR_MASS=__asseMg,
                                    CALC_FREQ=_F(OPTION='CENTRE',
                                                 FREQ=freq1,
                                                 NMAX_FREQ=nmode,),
                                    VERI_MODE=_F(STOP_ERREUR='OUI',
                                                 SEUIL=1.e-3,
                                                 STURM='NON',),);


          list_var=__modreel.LIST_VARI_ACCES()
          freq2=list_var['FREQ']
          dfreq=abs(freq1-freq2[0])
          __numod=0


          for ii in range(1,nmode-1):
              __new_dfreq=abs(freq1-freq2[ii])
              if __new_dfreq<dfreq:
                  dfreq=__new_dfreq
                  __numod=ii

          freq1=freq2[__numod]

          if __numod+1==nmode:
            nmode=nmode+5
            dfreq=freq1

          i=i+1

        __unmod=CREA_CHAMP(OPERATION='EXTR',
                          NOM_CHAM='DEPL',
                          TYPE_CHAM='NOEU_DEPL_R',
                          RESULTAT=__modreel,
                          NUME_ORDRE=__numod+1,);

        __tsmod=CREA_RESU(OPERATION='AFFE',
                         TYPE_RESU='MODE_MECA',
                         NOM_CHAM='DEPL',
                         MATR_MASS=__asseMg,
                         AFFE=_F(CHAM_GD=__unmod,
                                 NUME_MODE=j+1,
                                 FREQ=freq1,),);

          
        freq1=freq2[__numod+1]

        while freq1<=fmax:
            dfreq=freq1
            j=j+1

            
            while abs(dfreq)>=EPSILON*freq1:

              if i>10:
                nmode=nmode+5
                i=0

              __asseKw=__asseKg
              ny=0
              betab=NP.real(trKg)
              betah=NP.imag(trKg)

              for y in MATER_ELAS_FO:
                  e=y['E'](freq1)
                  eta=y['AMOR_HYST'](freq1)

                  __asseKw=COMB_MATR_ASSE(COMB_C=(_F(MATR_ASSE=__asseKw,
                                                  COEF_R=1.),
                                               _F(MATR_ASSE=__listKv[ny],
                                                  COEF_C=('RI',e/e0[ny]-1,eta*e/e0[ny]-eta0[ny],),),),)

                  betab=betab+(e/e0[ny]-1)*ltrv[ny]
                  betah=betah+(eta*e/e0[ny]-eta0[ny])*ltrv[ny]
                  ny=ny+1

              __asseKw=COMB_MATR_ASSE(COMB_R=(_F(MATR_ASSE=__asseKw,
                                                PARTIE='REEL',
                                                COEF_R=1.),
                                            _F(MATR_ASSE=__asseKw,
                                                PARTIE='IMAG',
                                                COEF_R=betah/betab,),),)


              __modreel=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                          MATR_MASS=__asseMg,
                                          CALC_FREQ=_F(OPTION='CENTRE',
                                                       FREQ=freq1,
                                                       NMAX_FREQ=nmode,),
                                          VERI_MODE=_F(STOP_ERREUR='OUI',
                                                       SEUIL=1.e-3,
                                                       STURM='NON',),);

              list_var=__modreel.LIST_VARI_ACCES()
              freq2=list_var['FREQ']
              dfreq=abs(freq1-freq2[0])
              __numod=0

              for ii in range(1,nmode-1):
                  __new_dfreq=abs(freq1-freq2[ii])
                  if __new_dfreq<dfreq:
                      dfreq=__new_dfreq
                      __numod=ii

              freq1=freq2[__numod]

              if __numod+1==nmode:
                nmode=nmode+5
                dfreq=freq1

              i=i+1
         
            __unmod=CREA_CHAMP(OPERATION='EXTR',
                              NOM_CHAM='DEPL',
                              TYPE_CHAM='NOEU_DEPL_R',
                              RESULTAT=__modreel,
                              NUME_ORDRE=__numod+1,);

            __tsmod=CREA_RESU(reuse=__tsmod,
                             OPERATION='AFFE',
                             TYPE_RESU='MODE_MECA',
                             NOM_CHAM='DEPL',
                             MATR_MASS=__asseMg,
                             AFFE=_F(CHAM_GD=__unmod,
                                     NUME_MODE=j+1,
                                     FREQ=freq1,
                                     ),);

            freq1=freq2[__numod+1]
            
            DETRUIRE(CONCEPT = _F (NOM = __modreel,) , )

        UTMESS('I', 'DYNA_VISCO_1')

        modes=DEFI_BASE_MODALE(ORTHO_BASE=_F(BASE=__tsmod,
                                             MATRICE=__asseMg,),
                               INFO=2,);

    elif TYPE_MODE=='REEL':

        while abs(dfreq)>=EPSILON*freq1:

          if i>10:
            nmode=nmode+5
            i=0

          __asseKw=__asseKgr
          ny=0

          for y in MATER_ELAS_FO:
              e=y['E'](freq1)
              eta=y['AMOR_HYST'](freq1)

              __asseKw=COMB_MATR_ASSE(COMB_R=(_F(MATR_ASSE=__asseKw,
                                                COEF_R=1.),
                                             _F(MATR_ASSE=__listKv[ny],
                                                COEF_R=e/e0[ny]-1,),),)

              ny=ny+1

          __modreel=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                    MATR_MASS=__asseMg,
                                    CALC_FREQ=_F(OPTION='CENTRE',
                                                 FREQ=freq1,
                                                 NMAX_FREQ=nmode,),
                                    VERI_MODE=_F(STOP_ERREUR='OUI',
                                                 SEUIL=1.e-3,
                                                 STURM='NON',),);

          list_var=__modreel.LIST_VARI_ACCES()
          freq2=list_var['FREQ']
          dfreq=abs(freq1-freq2[0])
          __numod=0


          for ii in range(1,nmode-1):
              __new_dfreq=abs(freq1-freq2[ii])
              if __new_dfreq<dfreq:
                  dfreq=__new_dfreq
                  __numod=ii

          freq1=freq2[__numod]

          if __numod+1==nmode:
            nmode=nmode+5
            dfreq=freq1

          i=i+1

        __unmod=CREA_CHAMP(OPERATION='EXTR',
                          NOM_CHAM='DEPL',
                          TYPE_CHAM='NOEU_DEPL_R',
                          RESULTAT=__modreel,
                          NUME_ORDRE=__numod+1,);

        __tsmod=CREA_RESU(OPERATION='AFFE',
                         TYPE_RESU='MODE_MECA',
                         NOM_CHAM='DEPL',
                         MATR_MASS=__asseMg,
                         AFFE=_F(CHAM_GD=__unmod,
                                 NUME_MODE=j+1,
                                 FREQ=freq1,
                                 ),);

        freq1=freq2[__numod+1]

        while freq1<=fmax:
            dfreq=freq1
            j=j+1
            #while abs(dfreq)>=1.e-3*freq1:
            while abs(dfreq)>=EPSILON*freq1:

              if i>10:
                nmode=nmode+5
                i=0

              __asseKw=__asseKgr
              ny=0
              for y in MATER_ELAS_FO:
                  e=y['E'](freq1)
                  eta=y['AMOR_HYST'](freq1)

                  __asseKw=COMB_MATR_ASSE(COMB_R=(_F(MATR_ASSE=__asseKw,
                                                   COEF_R=1.),
                                                _F(MATR_ASSE=__listKv[ny],
                                                   COEF_R=e/e0[ny]-1,),),)
                  ny=ny+1

              __modreel=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                        MATR_MASS=__asseMg,
                                        CALC_FREQ=_F(OPTION='CENTRE',
                                                     FREQ=freq1,
                                                     NMAX_FREQ=nmode,),
                                        VERI_MODE=_F(STOP_ERREUR='OUI',
                                                     SEUIL=1.e-3,
                                                     STURM='NON',),);

              list_var=__modreel.LIST_VARI_ACCES()
              freq2=list_var['FREQ']
              dfreq=abs(freq1-freq2[0])
              __numod=0

              for ii in range(1,nmode-1):
                  __new_dfreq=abs(freq1-freq2[ii])
                  if __new_dfreq<dfreq:
                      dfreq=__new_dfreq
                      __numod=ii

              freq1=freq2[__numod]

              if __numod+1==nmode:
                nmode=nmode+5
                dfreq=freq1

              i=i+1
 
            __unmod=CREA_CHAMP(OPERATION='EXTR',
                              NOM_CHAM='DEPL',
                              TYPE_CHAM='NOEU_DEPL_R',
                              RESULTAT=__modreel,
                              NUME_ORDRE=__numod+1,);

            __tsmod=CREA_RESU(reuse=__tsmod,
                             OPERATION='AFFE',
                             TYPE_RESU='MODE_MECA',
                             NOM_CHAM='DEPL',
                             MATR_MASS=__asseMg,
                             AFFE=_F(CHAM_GD=__unmod,
                                     NUME_MODE=j+1,
                                     FREQ=freq1,
                                     ),);

            freq1=freq2[__numod+1]

            DETRUIRE(CONCEPT = _F (NOM = __modreel,) , )

        UTMESS('I', 'DYNA_VISCO_1')

        modes=DEFI_BASE_MODALE(ORTHO_BASE=_F(BASE=__tsmod,
                                             MATRICE=__asseMg,),
                               INFO=2,);

    elif TYPE_MODE=='COMPLEXE':

        while abs(dfreq)>=EPSILON*freq1:

          if i>10:
            nmode=nmode+5
            i=0


          __asseKw=__asseKg
          ny=0

          for y in MATER_ELAS_FO:
              e=y['E'](freq1)
              eta=y['AMOR_HYST'](freq1)

              __asseKw=COMB_MATR_ASSE(COMB_C=(_F(MATR_ASSE=__asseKw,
                                                COEF_R=1.),
                                             _F(MATR_ASSE=__listKv[ny],
                                                COEF_C=('RI',e/e0[ny]-1,eta*e/e0[ny]-eta0[ny],),),),)
              ny=ny+1

          __modc=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                  MATR_MASS=__asseMg,
                                  CALC_FREQ=_F(OPTION='CENTRE',
                                               FREQ=freq1,
                                               NMAX_FREQ=nmode,),
                                  VERI_MODE=_F(STOP_ERREUR='OUI',
                                               SEUIL=1.e-3,
                                               STURM='NON',),);


          list_var=__modc.LIST_VARI_ACCES()
          freq2=list_var['FREQ']
          dfreq=abs(freq1-freq2[0])
          __numod=0

          for ii in range(1,len(freq2)):
              __new_dfreq=abs(freq1-freq2[ii])
              if __new_dfreq<dfreq:
                  dfreq=__new_dfreq
                  __numod=ii

          freq1=freq2[__numod]

          if __numod+1==nmode:
            nmode=nmode+5
            dfreq=freq1

          i=i+1

        __unmod=CREA_CHAMP(OPERATION='EXTR',
                          NOM_CHAM='DEPL',
                          TYPE_CHAM='NOEU_DEPL_C',
                          RESULTAT=__modc,
                          NUME_ORDRE=__numod+1,);

        modes=CREA_RESU(OPERATION='AFFE',
                         TYPE_RESU='MODE_MECA',
                         NOM_CHAM='DEPL',
                         MATR_MASS=__asseMg,
                         AFFE=_F(CHAM_GD=__unmod,
                                 NUME_MODE=j+1,
                                 FREQ=freq1,),);

        if AMOR:

          nom=__modc.nom
          rechamor=aster.getvectjev(nom.ljust(19)+'.RSPR        ')
          amor_mod=amor_mod+[0]
          amor_mod[j]=rechamor[__numod*24+1]
            
          rechfreq=aster.getvectjev(nom.ljust(19)+'.RSPR        ')
          freqp=freqp+[0]
          freqp[j]=rechfreq[__numod*24+14]

       


        freq1=freq2[__numod+1]

        while freq1<=fmax:
            dfreq=freq1
            j=j+1
            while abs(dfreq)>=EPSILON*freq1:

              if i>10:
                nmode=nmode+5
                i=0


              __asseKw=__asseKg
              ny=0
              for y in MATER_ELAS_FO:
                  e=y['E'](freq1)
                  eta=y['AMOR_HYST'](freq1)

                  __asseKw=COMB_MATR_ASSE(COMB_C=(_F(MATR_ASSE=__asseKw,
                                                    COEF_R=1.),
                                                 _F(MATR_ASSE=__listKv[ny],
                                                    COEF_C=('RI',e/e0[ny]-1,eta*e/e0[ny]-eta0[ny],),),),)
                  ny=ny+1

              __modc=MODE_ITER_SIMULT(MATR_RIGI=__asseKw,
                                  MATR_MASS=__asseMg,
                                  CALC_FREQ=_F(OPTION='CENTRE',
                                               FREQ=freq1,
                                               NMAX_FREQ=nmode,),
                                  VERI_MODE=_F(STOP_ERREUR='OUI',
                                               SEUIL=1.e-3,
                                               STURM='NON',),);




              list_var=__modc.LIST_VARI_ACCES()
              freq2=list_var['FREQ']
              dfreq=abs(freq1-freq2[0])
              __numod=0


              for ii in range(1,len(freq2)):
                  __new_dfreq=abs(freq1-freq2[ii])
                  if __new_dfreq<dfreq:
                      dfreq=__new_dfreq
                      __numod=ii

              freq1=freq2[__numod]

              if __numod+1==nmode:
                nmode=nmode+5
                dfreq=freq1

              i=i+1

            __unmod=CREA_CHAMP(OPERATION='EXTR',
                              NOM_CHAM='DEPL',
                              TYPE_CHAM='NOEU_DEPL_C',
                              RESULTAT=__modc,
                              NUME_ORDRE=__numod+1,);

            modes=CREA_RESU(reuse=modes,
                             OPERATION='AFFE',
                             TYPE_RESU='MODE_MECA',
                             NOM_CHAM='DEPL',
                             MATR_MASS=__asseMg,
                             AFFE=_F(CHAM_GD=__unmod,
                                    NUME_MODE=j+1,
                                    FREQ=freq1,),);

            freq1=freq2[__numod+1]

# On recherche les valeurs des amortissements et des frequences propres des modes

            if AMOR:

              nom=__modc.nom
              rechamor=aster.getvectjev(nom.ljust(19)+'.RSPR        ')
              amor_mod=amor_mod+[0]
              amor_mod[j]=rechamor[__numod*24+1]
              
              rechfreq=aster.getvectjev(nom.ljust(19)+'.RSPR        ')
              freqp=freqp+[0]
              freqp[j]=rechfreq[__numod*24+14]

      #if AMOR:

              amor=CREA_TABLE(LISTE=(_F(LISTE_R=freqp,
                                        PARA='frequences',),
                                     _F(LISTE_R=amor_mod,
                                        PARA='amortissements',),),);    
              return amor
     

    DETRUIRE(CONCEPT = _F (NOM = __asseKw,) , )


    return modes



